import cheerio from "cheerio";
import { isTypeReferenceNode } from "typescript";

export namespace Template {
    export async function check(html: string) {
        try {
            const $ = cheerio.load(html);

            return false;
        } catch (error) {
            console.error(`Error occured during stock check!`);
            return false;
        }
    }
}


export namespace FitnessKoerier {
    export async function check(html: string) {
        try {
            const $ = cheerio.load(html);
            if ($('.product-list .stock-msg').find("[itemprop=availability]").attr("content") == "out_of_stock") {
                return false;
            } else {
                return true;
            }
        } catch (error) {
            console.log(error);
            console.error(`Error occured during stock check!`);
            return false;
        }
    }
}


export namespace FitnessApparaat {
    export async function check(html: string) {
        try {
            const $ = cheerio.load(html);
            if ($('[itemprop="offers"]').find(".stock-red").length >= 1) {
                return false;
            } else {
                return true;
            }
        } catch (error) {
            console.log(error);
            console.error(`Error occured during stock check!`);
            return false;
        }
    }
}

export namespace BolCom {
    export async function check(html: string) {
        try {
            const $ = cheerio.load(html);
            let stock = false;

            $('script[type="application/ld+json"]').each((index, element) => {
                let json = JSON.parse($(element).html());
            
                if (json["@type"]) {
                    if (json["@type"] == "Product") {
                        if (json["offers"]["availability"].includes("InStock")) {
                            stock = true;
                            return;
                        }
                    }
                }
            });

            return stock;
        } catch (error) {
            console.log(error);
            console.error(`Error occured during stock check!`);
            return false;
        }
    }
}

export namespace WifiMedia {
    export async function check(html: string) {
        try {
            const $ = cheerio.load(html);
            
            if ($("[itemprop=availability]").first().attr("content") == "http://schema.org/InStock") {
                return true;
            }
            
            return false;
        } catch (error) {
            console.log(error);
            console.error(`Error occured during stock check!`);
            return false;
        }
    }
}


export namespace Maxiaxi {
    export async function check(html: string) {
        try {
            const $ = cheerio.load(html);
            let stock = false;

            $('script[type="application/ld+json"]').each((index, element) => {
                let json = JSON.parse($(element).html());
            
                if (json["@type"]) {
                    if (json["@type"] == "Product") {
                        if (json["offers"][0]["availability"] == "http://schema.org/InStock") {
                            stock = true;
                            return;
                        }
                    }
                }
            });

            return stock;
        } catch (error) {
            console.log(error);
            console.error(`Error occured during stock check!`);
            return false;
        }
    }
}